//+------------------------------------------------------------------+
//|                                                      Dornasho ea |
//|                        Copyright 2016, Dornasho                  |
//|                                          http://tradelikeapro.ru |
//+------------------------------------------------------------------+
#property copyright "Dornasho"
#property link      "http://tradelikeapro.ru"
#property version   "1.00"
#property strict

extern string ___ORDERS_PARAMETERS___ = "===ORDERS_PARAMETERS===";
int et=0;
extern string ordercomment ="Dornasho v1.02";
bool os,oc;
extern bool USE_AUTO_MM = FALSE ;
extern double Fixed_LOT = 0.1;
extern double AutoMM = 2;
double lot; 
extern int Slippage = 2;
extern int Magic=20042;
extern int MaxSpread= 4;
extern string ___MA_PARAMETERS___ = "===MA-PARAMETERS===";
extern ENUM_TIMEFRAMES MA_TIMEFRAME = PERIOD_M15;
extern int MA_PERIOD = 75;
extern int MA_SHIFT = 0;
extern ENUM_MA_METHOD MA_METHOD = MODE_SMMA; 
extern ENUM_APPLIED_PRICE MA_APPLIED_PRICE = PRICE_CLOSE;
extern int  IMA_SHIFT = 1;
extern string ___WPR_PARAMETERS___ = "===WPR-PARAMETERS===";
extern ENUM_TIMEFRAMES WPR_TIMEFRAME = PERIOD_M15;
extern int WPR_PERIOD = 12;
extern int  WPR_SHIFT = 1;
extern string ___IATR_PARAMETERS___ = "===IATR-PARAMETERS===";
extern ENUM_TIMEFRAMES ATR_TIMEFRAME = PERIOD_M15;
extern int ATR_PERIOD = 14;
extern int  ATR_SHIFT = 0;
extern string ___ICCI_PARAMETERS___ = "===ICCI-PARAMETERS===";
extern ENUM_TIMEFRAMES CCI_TIMEFRAME = PERIOD_M15;
extern int CCI_PERIOD = 12;
extern ENUM_APPLIED_PRICE CCI_APPLIED_PRICE = PRICE_CLOSE;
extern int  CCI_SHIFT = 1;
extern string ___BOLINGERBAND_PARAMETERS___ = "===BOLINGERBAND_PARAMETERS===";
extern ENUM_TIMEFRAMES BOLINGER_TIMEFRAME = PERIOD_M15;
extern int BOLINGER_PERIOD = 21;
extern int BOLINGER_DEVISATION = 2;
extern int BOLINGER_SHIFT = 0;
extern ENUM_APPLIED_PRICE BOLINGER_APPLIED_PRICE = PRICE_CLOSE;
extern int IBOLINGER_SHIFT = 1;
extern string ___PARAMETERS_FOR_OPEN_ORDER___ = "===___PARAMETERS_FOR_OPEN_ORDER___===";
extern double MA_SPACE = 10;
extern double WPR_FOR_SELL = -6;
extern double WPR_FOR_BUY = -94;
extern double ATR = 6;
extern double CCI_FOR_SELL = 290 ;
extern double CCI_FOR_BUY = -290 ;
extern double SPASE_FROM_UPPER_Bolinger = 0;
extern double SPASE_FROM_LOWER_Bolinger = 0;
extern string ___PARAMETERS_FOR_CLOSE___ = "===___PARAMETERS_FOR_CLOSE___===";
extern int SL = 120;
extern int TP = 18;
extern double WPR_SELL = -81;
extern double WPR_BUY = -19;

int Fdatetime = 0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1))
   {
      TP        *= 10;
      SL        *= 10;
      Slippage  *= 10;
      ATR       *= 10;
      MA_SPACE  *= 10;
      MaxSpread *= 10;
      SPASE_FROM_UPPER_Bolinger *= 10;
      SPASE_FROM_LOWER_Bolinger *= 10;
   }
   return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {


if (USE_AUTO_MM  == 0) lot=Fixed_LOT;
if (USE_AUTO_MM  == 1) lot=(MathMax(0.01, MathMin(10000, MathCeil(MathMin(AutoMM, AutoMM) / 1 / 100.0 * AccountBalance() / 0.01 / (100000 / 100)) * 0.01)));
double close = iClose(NULL,PERIOD_M15,1);
double ima = iMA(Symbol(),MA_TIMEFRAME, MA_PERIOD, MA_SHIFT, MA_METHOD, MA_APPLIED_PRICE, IMA_SHIFT);
double wpr= iWPR(NULL,WPR_TIMEFRAME,WPR_PERIOD,WPR_SHIFT);
double atr=iATR(Symbol(),ATR_TIMEFRAME,ATR_PERIOD,ATR_SHIFT);
double cci = iCCI(NULL,CCI_TIMEFRAME,CCI_PERIOD,CCI_APPLIED_PRICE,CCI_SHIFT);
double bolinger_UPPER=iBands(Symbol(),BOLINGER_TIMEFRAME,BOLINGER_PERIOD,BOLINGER_DEVISATION,BOLINGER_SHIFT,BOLINGER_APPLIED_PRICE,MODE_UPPER,IBOLINGER_SHIFT);
double bolinger_LOWER=iBands(Symbol(),BOLINGER_TIMEFRAME,BOLINGER_PERIOD,BOLINGER_DEVISATION,BOLINGER_SHIFT,BOLINGER_APPLIED_PRICE,MODE_LOWER,IBOLINGER_SHIFT);
if (atr < ATR*Point) return ;
et=0;
for (int ii = OrdersTotal() - 1; ii >= 0; ii--)
if (OrderSelect(ii, SELECT_BY_POS, MODE_TRADES)) {
if ( OrderMagicNumber()== Magic) et++; }
if (et<1  ) {

if (Ask - Bid < MaxSpread * Point) {

//sell
if ( (!(ima - (Point*MA_SPACE) <= close || ( WPR_FOR_SELL >= wpr && cci <= CCI_FOR_SELL) || close - Point   >= Bid)) && Bid>bolinger_UPPER+(Point*SPASE_FROM_UPPER_Bolinger))    

if (OrderSend(Symbol(),OP_SELL,lot,Bid,Slippage,0,0,ordercomment,Magic,0,Red)>0) return;  

//-buy

if ( !(ima + (Point*MA_SPACE) >= close ||( WPR_FOR_BUY <= wpr && cci >= CCI_FOR_BUY) || close + Point  <= Bid) && Bid<bolinger_LOWER-(Point*SPASE_FROM_LOWER_Bolinger))    

if (OrderSend(Symbol(),OP_BUY,lot,Ask,Slippage,0,0,ordercomment,Magic,0,Blue)>0) return;  }}


//sell close
for (int ee = OrdersTotal() - 1; ee >= 0; ee--)
if (OrderSelect(ee, SELECT_BY_POS, MODE_TRADES)) {
if ( OrderMagicNumber()==Magic && OrderType() == OP_SELL)   {
if ( Bid >= OrderOpenPrice() + (Point*SL) || wpr < WPR_SELL   || (Bid <= OrderOpenPrice() - (TP*Point)  && Bid<iClose(NULL,PERIOD_M1,1))  ) {
if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), Slippage, Violet)==1) return;  }}}
//----






//buy close
for (int bbb = OrdersTotal() - 1; bbb >= 0; bbb--)
if (OrderSelect(bbb, SELECT_BY_POS, MODE_TRADES)) {
if ( OrderMagicNumber()==Magic && OrderType() == OP_BUY)  {
if ( Bid <= OrderOpenPrice() - (Point*SL) || wpr > WPR_BUY   || (Bid >= OrderOpenPrice() + (TP*Point)  && Bid>iClose(NULL,PERIOD_M1,1))) {
if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), Slippage, Violet)==1)return; }}}

   
  }
//+------------------------------------------------------------------+
